/*
 * CFINGERD
 * Site checking routines
 */

#include "cfingerd.h"
#include "proto.h"

/*
 * CHECK_TRUSTED
 *
 * This routine returns a TRUE or FALSE, depending on if the passed host is
 * in the trusted host array.
 */
BOOL check_trusted(char *host)
{
    int i;

    for (i = 0; i < trusted_host_num; i++)
	if (strstr(host, prog_config.trusted[i])) {
	    syslog(LOG_NOTICE, "Finger from %s %s",
		host, prog_config.p_strings[D_TRUST_HOST]);
	    return(TRUE);
	}

    return(FALSE);
}

/*
 * CHECK_REJECTED
 *
 * This routine simply checks whether or not the listed host is part of the
 * list of rejected hosts.  If it's matched, it displays the rejected list
 * file and quits completely.
 */
void check_rejected(char *host)
{
    int i;

    for (i = 0; i < rejected_host_num; i++)
	if (strstr(host, prog_config.rejected[i])) {
	    syslog(LOG_NOTICE, "Finger from %s %s",
		host, prog_config.p_strings[D_REJECT_HOST]);
	    if (prog_config.config_bits2 & SHOW_REJECTED)
		display_file(prog_config.rejected_file);
	    exit(PROGRAM_OKAY);
	}
}
