/*
 * CFINGERD
 * Username search routines
 */

#include "cfingerd.h"
#include "proto.h"

typedef struct {
    char username[80];
    char realname[80];
} SEARCHLIST;

/*
 * SHOW_SEARCH
 *
 * This routine searches for the specified uname, or any matches in the
 * specified uname, and lists the matches that were made.
 */
void show_search(char *uname)
{
    char search[7], searchname[80];
    int num_searches = 0, fnd = 0;
    SEARCHLIST searches[100];
    FILE *file;

    show_top();
    sscanf(uname, "%[^.].%[^\r\n]\r\n", search, searchname);

    if (strlen((char *) searchname) == 0) {
	printf("\n                    You must supply a name to search for!\n");
	SEND_RAW_RETURN;
	show_bottom();
	exit(PROGRAM_OKAY);
    }

    file = fopen("/etc/passwd", "r");
    if (file) {
	while(!feof(file)) {
	    char crap[80], un[80], rn[80], crappp[80];

	    un[0] = 0;
	    rn[0] = 0;
	    crap[0] = 0;
	    fnd = FALSE;

	    fgets(crappp, 80, file);
	    sscanf(crappp, "%[^:\r\n]:\r\n%[^:\r\n]:\r\n%[^:\r\n]:\r\n%[^:\r\n]:\r\n%[^:\r\n]:\r\n%[^:\r\n]:\r\n%[^\r\n]\r\n",
		un, crap, crap, crap, rn, crap, crap);

	    if (!(strncasecmp(rn, searchname, strlen(searchname))))
		fnd = TRUE;
	    if (!(strncasecmp(un, searchname, strlen(searchname))))
		fnd = TRUE;
	    if (!(strcasecmp(rn, searchname)))
		fnd = TRUE;
	    if (!(strcasecmp(un, searchname)))
		fnd = TRUE;
	    if (strstr((char *) rn, (char *) searchname))
		fnd = TRUE;
	    if (strstr((char *) un, (char *) searchname))
		fnd = TRUE;

	    if (fnd) {
		char crap2[80];

		sscanf(rn, "%[^,\r\n],\r\n%[^,\r\n],\r\n%[^,\r\n],\r\n%[^\r\n]\r\n",
		    searches[num_searches].realname, crap2, crap2, crap2);
		strcpy(searches[num_searches].username, un);
		num_searches++;
	    }
	}
    } else {
	printf("\n                   Could not open the local password file!\n\n");
	show_bottom();
	exit(PROGRAM_OKAY);
    }

    if (num_searches > 0) {
	int i;

	printf("\n %d match%sfound regarding your search criteria:\n\n",
	    num_searches, (num_searches > 1) ? "es " : " ");
	printf(" Username:      Realname:\n");
	printf(" -------------- --------------------------------------------------------------\n");
	for(i = 0; i < num_searches; i++) {
	    printf(" %-14.14s %-61.61s\n", searches[i].username,
		searches[i].realname);
	}

	fflush(stdout);
    } else {
	printf("\n               No matches found regarding your search criteria.\n");
	fflush(stdout);
    }

    SEND_RAW_RETURN;

    show_bottom();
}
