/*
 * CFINGERD
 * String copy with automatic memory allocation
 */

#include <stdlib.h>
#include <string.h>
#include <syslog.h>

/*
 * STRMCPY
 *
 * DO NOT PREVIOUSLY ALLOCATE MEMORY!  This routine will automatically do
 * the memory allocations for you.  This is an advanced version of strcpy,
 * but returns memory allocation.  Very handy.
 */
void strmcpy(char **t, const char *s)
{
    if (*t != NULL)
	free(*t);

    *t = malloc(strlen(s) + 1);

    if (*t == NULL) {
	syslog(LOG_ERR, "strmcpy: alloc error");
	exit(1);
    }

    (void) strcpy(*t, s);
}
