/*
 * CFINGERD 1.1.0
 * Userlist handler
 */

#include "cfingerd.h"
#include "proto.h"

/*
 * HANDLE_USERLIST
 * 
 * This routine simply handles the displaying of the userlist.
 */
void handle_userlist(void)
{
    BOOL can_show = FALSE;

    if (local_finger) {
	if (prog_config.local_config_bits2 & SHOW_SYSTEMLIST)
	    can_show = TRUE;
    } else {
	if (prog_config.config_bits2 & SHOW_SYSTEMLIST)
	    can_show = TRUE;
    }

    if (can_show) {
	int i;

	show_top();

	if ((num_finger_sites > 1) &&
	    prog_config.config_bits2 & SHOW_MULTFING) {
	    printf("%s\n", prog_config.p_strings[D_WAIT]);
	    fflush(stdout);
	}

	system("rm -f /tmp/fslist");

	if (prog_config.config_bits2 & SHOW_MULTFING) {
	    for (i = 0; i < num_finger_sites; i++) {
		char site[80];

		if (!strncmp(prog_config.finger_sites[i], "localhost", 9)) {
		    char st[80];

		    sprintf(st, "%s | tail +2 >> /tmp/fslist",
			prog_config.finger_program);
		    system(st);
		} else {
		    sprintf(site, "finger userlist-only@%s | tail +3 >> /tmp/fslist",
			prog_config.finger_sites[i]);

		    system(site);
		}
	    }
	} else {
	    char st[80];

	    sprintf(st, "%s | tail +2 >> /tmp/fslist",
		prog_config.finger_program);
	    system(st);
	}

	system("cat /tmp/fslist | sort > /tmp/fslist.sort");
	system("mv /tmp/fslist.sort /tmp/fslist");

	if ((num_finger_sites > 1) &&
	    prog_config.config_bits2 & SHOW_MULTFING)
	    printf("\n**> This is the complete listing of %d sites total.\n\n",
		    num_finger_sites);

	printf("Username Real name                      Idletime TTY Remote console location\n");
	fflush(stdout);
	display_file("/tmp/fslist");

	if ((num_finger_sites > 1) &&
	    prog_config.config_bits2 & SHOW_MULTFING)
	    SEND_RAW_RETURN;

	if ((num_finger_sites > 1) &&
	    prog_config.config_bits2 & SHOW_MULTFING)
	    system("echo \"There are `cat /tmp/fslist | wc --lines` users online.\"");

	fflush(stdout);
	show_bottom();
    } else {
	can_show = FALSE;

	if (local_finger) {
	    if (prog_config.local_config_bits2 & SHOW_NN_BANNER)
		can_show = TRUE;
	} else {
	    if (prog_config.config_bits2 & SHOW_NN_BANNER)
		can_show = TRUE;
	}

	if (can_show)
	    display_file(prog_config.no_name_banner_file);
    }
}
