/*
 * USERLIST
 * Initialization routines
 */

#include "userlist.h"
#include "proto.h"
#include "config.h"
#ifdef	BSD
#include "../src/getutent.h"
#endif

#include <ctype.h>

TTY_FROM tty_list[MAX_TTYS];
int times_on;

char *remove_crap(char *str)
{
    char *ret;
    int i, x = 0;

    ret = (char *) malloc(strlen(str));
    for (i = 0; i < strlen(str); i++)
	if (isalnum(str[i]) || (str[i] == '.') || (str[i] == '-'))
	    ret[x++] = str[i];

    return(ret);
}

void initialize_userlist(void)
{
    struct utmp *ut;

    times_on = 0;

    while((ut = getutent()) != NULL)
#ifdef	BSD
	{
	    tty_list[times_on].username = malloc(UT_NAMESIZE);
	    tty_list[times_on].tty = malloc(2);
	    tty_list[times_on].locale = malloc(UT_HOSTSIZE);

	    strcpy(tty_list[times_on].username, (char *) ut->ut_name);
	    strcpy(tty_list[times_on].tty, "");
	    strcpy(tty_list[times_on].locale, (char *) ut->ut_host);

	    tty_list[times_on].ip_addr = 0;
	    tty_list[times_on].time = ut->ut_time;
#else
	if (ut->ut_type == USER_PROCESS) {
	    tty_list[times_on].username = malloc(8);
	    tty_list[times_on].tty = malloc(2);
	    tty_list[times_on].locale = malloc(16);

	    strcpy(tty_list[times_on].username, (char *) ut->ut_user);
	    strcpy(tty_list[times_on].tty, (char *) ut->ut_id);
	    strcpy(tty_list[times_on].locale, (char *) ut->ut_host);

	    tty_list[times_on].ip_addr = ut->ut_addr;
	    tty_list[times_on].time = ut->ut_time;
	    times_on++;
#endif
	}
}
